'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var react = require('react');
var axios = _interopDefault(require('axios'));
var isOnline = _interopDefault(require('is-online'));
var root = _interopDefault(require('window-or-global'));

var index = (function (_a) {
    var children = _a.children, _b = _a.skip, skip = _b === void 0 ? false : _b, config = _a.config;
    var _c = react.useState(false), loading = _c[0], setLoading = _c[1];
    var _d = react.useState(null), error = _d[0], setError = _d[1];
    var _e = react.useState(null), response = _e[0], setResponse = _e[1];
    var _f = react.useState(null), networkStatus = _f[0], setNetworkStatus = _f[1];
    react.useEffect(function () {
        checkNetworkConnection();
        if (!skip) {
            fetch();
        }
    }, []);
    var checkNetworkConnection = function () {
        if ((typeof document != 'undefined') && root && isOnline) {
            root.addEventListener('offline', function () {
                isOnline({ timeout: 1000 })
                    .then(function (online) {
                    if (!online) {
                        setNetworkStatus('offline');
                    }
                });
            });
            root.addEventListener('online', function () {
                isOnline({ timeout: 1000 })
                    .then(function (online) {
                    if (online) {
                        setNetworkStatus('online');
                    }
                });
            });
            isOnline({ timeout: 1000 })
                .then(function (online) {
                if ((online && networkStatus !== 'online') || (!online && networkStatus !== 'offline')) {
                    setNetworkStatus(online ? 'online' : 'offline');
                }
            });
        }
    };
    var fetch = function () {
        if (config) {
            setLoading(true);
            axios(config)
                .then(function (response) {
                setResponse(response);
                setLoading(false);
            })
                .catch(function (error) {
                setError(error);
                setLoading(false);
            });
        }
    };
    // @ts-ignore
    return children({ loading: loading, error: error, response: response, refetch: fetch, networkStatus: networkStatus });
});

exports.default = index;
//# sourceMappingURL=index.js.map
